public class StackArrayBased 
                 implements StackInterface {
  final int MAX_STACK = 50;  // maximum size of stack
  private Object items[];
  private int top;

  public StackArrayBased() {
    items = new Object[MAX_STACK]; 
    top = -1; 
  }  // end default constructor

  public boolean isEmpty() {
    return top < 0;
  }  // end isEmpty

  public boolean isFull() {
    return top == MAX_STACK-1;
  }  // end isFull

  public void push(Object newItem) throws StackException {
    if (!isFull()) {
      items[++top] = newItem;
    } 
    else {
      throw new StackException("StackException on " +
                               "push: stack full");
    }  // end if
  }  // end push

  public void popAll() {
    items = new Object[MAX_STACK]; 
    top = -1; 
  }  // end popAll
  
  public Object pop() throws StackException {
    if (!isEmpty()) {
      return items[top--];
    }
    else {
      throw new StackException("StackException on " +
                               "pop: stack empty");
    }  // end if
  }  // end pop

  public Object peek(int i) throws StackException, IllegalArgumentException {
    if (!isEmpty()) {
      if ((i < 0) || (i > items.length)) 
        throw new IllegalArgumentException("Invalid index for peek: " + i);
      else
        return items[top-i];
    }
    else {
      throw new StackException("Stack exception on " +
                               "peek - stack empty");
    }  // end if
  }  // end peek

  public Object clone()
  {
     StackArrayBased o = new StackArrayBased();
     o.top = top;
     for (int i=0; i<items.length; i++)
       o.items[i] = items[i];    
     return o;
  }
}  // end StackArrayBased
