public class StackReferenceBased 
                  implements StackInterface {
  private Node top;

  public StackReferenceBased() {
    top = null; 
  }  // end default constructor
  
  public boolean isEmpty() {
    return top ==  null;
  }  // end isEmpty

  public void push(Object newItem) {
    top = new Node(newItem, top);
  }  // end push
  
  public Object pop() throws StackException {
    if (!isEmpty()) {
      Node temp = top;
      top = top.getNext();
      return temp.getItem();
    }
    else {
      throw new StackException("StackException on " +
                               "pop: stack empty");
    }  // end if
  }  // end pop
  
  public void popAll() {
    top = null;
  }  // end popAll
  
  public Object peek(int i) throws StackException, IllegalArgumentException {
    if (!isEmpty()) {
      Node curr = top;
      if (i < 0)
        throw new IllegalArgumentException("Illegal Argument to peek: " + i);
      while (i-- > 0 && curr != null)
        curr = curr.getNext();
      if (curr == null) throw new IllegalArgumentException("Illegal Argument to peek: " + i);
      return curr.getItem();
    }
    else {
      throw new StackException("StackException on " +
                               "peek: stack empty");
    }  // end if
  }  // end peek

  public Object clone()
  {
    StackReferenceBased o = new StackReferenceBased();
    
    // create the top node of the new stack
    Node newNode = new Node(top.getItem());
    o.top = newNode;

    Node last = newNode;
    Node curr = top.getNext();
    while (curr != null)
    {
      Node newNode = new Node(curr.getItem());
      last.setNext(newNode);
      last = newNode;
      curr = curr.getNext();
    }
    return o;
  }
}  // end StackReferenceBased
